require "./AI/USER_AI/UserHead.lua"
require "./AI/USER_AI/SelfStudy/MonsterListHead.lua"
require "./AI/USER_AI/SelfStudy/DistanceListHead.lua"

function GetPriorityOfMonster(monsterid, distancefromowner)
	
	if(IsExistMonster(monsterid) == false) then
		InitMonster(monsterid)
	end
	
	local mobpriority = MobPointList[monsterid][PRIORITY]
	local mhpoint = MobPointList[monsterid][MH]
	local actor = GetActors()
	local mhcount = 0
	local distance
	
	
	if (distancefromowner > 9) then
		distance = 9
	else
		distance = distancefromowner
	end
	local dispriority = DisPointList[distance]
	
	
	for i,v in ipairs(actor) do
		if (GetV(V_HOMUNTYPE,v) == monsterid) then
			mhcount = mhcount + 1
		end
	end
	
	if (mhcount > 9) then
		mhcount = 9
	end
	
	mhpoint = 10 - mhpoint
	mhcount = 10 - mhcount
	
	if (mhpoint < mhcount) then
		mhpoint = mhpoint / mhcount
	else
		mhpoint = mhcount / mhpoint
	end
	
	return mobpriority * dispriority * mhpoint
end



function GetPriorityOfAutoskill(monsterid)
	
	if(IsExistMonster(monsterid) == false) then
		InitMonster(monsterid)
	end
	
	local autoskillpriority = MobPointList[monsterid][AUTO_SKILL]
	
	return autoskillpriority
end



function SetDataOfSituation1(monsterid, addmonsterpoint)
	if(IsExistMonster(monsterid) == false) then
		InitMonster(monsterid)
	end
	
	local monsterpoint		= MobPointList[monsterid][PRIORITY]
	local autoskillpoint	= MobPointList[monsterid][AUTO_SKILL]
	local mhpoint			= MobPointList[monsterid][MH]
	
	if (monsterpoint ~= nil) then
		if (mhpoint ~= nil) then
			UpdateMonster(monsterid, monsterpoint + addmonsterpoint,autoskillpoint,mhpoint)
		else
			UpdateMonster(monsterid, monsterpoint + addmonsterpoint,autoskillpoint,0)
		end
	else
		if (mhpoint ~= nil) then
			UpdateMonster(monsterid, monsterpoint,autoskillpoint,mhpoint)
		else
			UpdateMonster(monsterid, monsterpoint,autoskillpoint,0)
		end
	end
end




function SetDataOfSituation2(monsterid, addmonsterpoint, addautoskillpoint, distance)
	if(IsExistMonster(monsterid) == false) then
		InitMonster(monsterid)
	end
	
	local monsterpoint = MobPointList[monsterid][PRIORITY]
	local autoskillpoint = MobPointList[monsterid][AUTO_SKILL]
	local mhpoint = MobPointList[monsterid][MH]
	
	local actor = GetActors()
	local mhcount = 0
	
	for i,v in ipairs(actor) do
		if (monsterid == GetV(V_HOMUNTYPE,v)) then
			mhcount = mhcount + 1
		end
	end
	
	if (mhcount > 9) then
		mhcount = 9
	end
	
	mhpoint = (mhpoint + mhcount + 1) / 2
	
	if (distance > 9) then
		distance = 9
	end	
	
	UpdateMonster(monsterid, monsterpoint + addmonsterpoint, autoskillpoint + addautoskillpoint, mhpoint)
	local SortingDisList = SortDisList(distance)
	
	local i = 0
	while true do
		if (DisPointList[distance] > (10000 - RATE_DISTANCE_REFLECTION)) then
			return
		end
		
		local v = SortingDisList[i]
		if (i < 1) then
			UpdateDistance(v, DisPointList[v] + 5)
		elseif (i < 3) then
			UpdateDistance(v, DisPointList[v] + 3)
		elseif (i < 5) then
			UpdateDistance(v, DisPointList[v] + 1)
		elseif (i < 7) then
			UpdateDistance(v, DisPointList[v] - 1)
		elseif (i < 9) then
			UpdateDistance(v, DisPointList[v] - 3)
		elseif (i < 10) then
			UpdateDistance(v, DisPointList[v] - 5)
		else
			return
		end
		i = i + 1
	end
end



function SaveStudyData()
	SaveMonster()
	SaveDistance()
end

